﻿using System;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.DomainServices.Server;
using System.ServiceModel.DomainServices.Hosting;
using System.Collections.Generic;

namespace Sandworks.Silverlight.nTier.Services
{
    [ServiceBehavior(AddressFilterMode=AddressFilterMode.Any)]
    [EnableClientAccess()]
    public class TasksDomainService : DomainService
    {
        private static List<Task> addedTasks;

        public TasksDomainService()
        {
            if (addedTasks == null)
                addedTasks = new List<Task>();
        }

        [Insert]
        public void AddTask(Task task)
        {
            task.Id = Guid.NewGuid();
            task.AddedOn = DateTime.Now;
            addedTasks.Add(task);
        }

        [Update]
        public void UpdateTask(Task task)
        {
            Task t = addedTasks.FirstOrDefault(o => o.Id == task.Id);
            t.Owner = task.Owner;
            t.Subject = task.Subject;
        }
        
        [Query]
        public IQueryable<Task> GetTasks()
        {
            var tasks = new List<Task>();
            tasks.Add(new Task("Sandrino", "Finish article"));
            tasks.Add(new Task("Kevin", "Prepare RIA session."));
            tasks.Add(new Task("Gert", "Finish Silverlight project."));
            tasks.AddRange(addedTasks);
            return tasks.AsQueryable();
        }


        public override bool Submit(ChangeSet changeSet)
        {
            return base.Submit(changeSet);
        }
    }
}


